

//globals...
bool lmb, mmb;
int mouse_press_x, mouse_press_y;
GLfloat spin_x, spin_y, dolly, trans_x, trans_y;



//display...
   glPushMatrix();
    glTranslatef(trans_x, trans_y, dolly);
    glRotatef(spin_x, 1.0, 0.0, 0.0);

    glPushMatrix();
     glRotatef(spin_y, 0.0, 1.0, 0.0);

     glPushMatrix();
      gluLookAt(20, 0, 20, 0, 0, 0, 0, 1, 0);

      //draw stuff in here...
     glPopMatrix();

    glPopMatrix();

   glPopMatrix();



/* Mouse input function ======================================================*/
void mouse(int button, int state, int x, int y)
{
   if(state == GLUT_DOWN)
   {
      mouse_press_x = x; mouse_press_y = y;

      switch(button)
      {
         case GLUT_LEFT_BUTTON:
            lmb = true;
            break;

         case GLUT_MIDDLE_BUTTON:
            mmb = true;
            break;

         default:
            break;
      }
   }

   if(state == GLUT_UP)
   {
      glutSetCursor(GLUT_CURSOR_NONE);
      switch(button)
      {
         case GLUT_LEFT_BUTTON:
            lmb = false;
            break;

         case GLUT_MIDDLE_BUTTON:
            mmb = false;
            break;

         default:
            break;
      }
   }

   glutPostRedisplay();
}

/* Motion function ===========================================================*/
void motion(int x, int y)
{
   int step_x = (x - mouse_press_x), step_y = (y - mouse_press_y);

   mouse_press_x = x; mouse_press_y = y;

   if(lmb && !mmb)        /* Tumble */
   {
#ifdef WIN32
      glutSetCursor(GLUT_CURSOR_CROSSHAIR);
#else
      glutSetCursor(GLUT_CURSOR_CYCLE);
#endif
      spin_x += 0.5*step_y;
      spin_y += 0.5*step_x;
   }
   else if(mmb && !lmb)   /* Translate */
   {
#ifdef WIN32
      glutSetCursor(GLUT_CURSOR_SPRAY);
#else
      glutSetCursor(GLUT_CURSOR_CROSSHAIR);
#endif
      trans_x += 0.03*step_x;
      trans_y -= 0.03*step_y;
   }
   else if(lmb && mmb)    /* Dolly */
   {
      glutSetCursor(GLUT_CURSOR_LEFT_RIGHT);
      dolly += 0.03*step_x;
   }
   glutPostRedisplay();
}
